package edu.columbia.sip;

import com.sun.java.swing.JFrame;
import com.sun.java.swing.JButton;
import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTextArea;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.ImageIcon;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.JTabbedPane;
import com.sun.java.swing.UIManager;

import com.sun.java.swing.border.Border;
import com.sun.java.swing.BorderFactory;

import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.Container;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class BuddyListApp extends JFrame {
    public static String _username;
    public static String _password;
    
    SIPServer _server;

    public BuddyListApp() {
        Container c = getContentPane();
        setTitle("SIP Buddy List System: " + _username);
        GridBagLayout gridbag = new GridBagLayout();
        c.setLayout(gridbag);
        GridBagConstraints constr = new GridBagConstraints();
        
        // set up top of main window with image button
        ImageIcon logo = new ImageIcon("buddylist.gif");
        JButton home = new JButton(logo);
        home.setBorder(BorderFactory.createRaisedBevelBorder());
        
        home.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                // open netscape to our home page
                Runtime rt = Runtime.getRuntime();
                String platform = System.getProperty("os.name");
                String netscape;
                if (platform.startsWith("Windows")) {
                    netscape = "C:\\program files\\netscape\\communicator\\program\\netscape";
                } else {
                    netscape = "netscape";
                }
                try {
                    rt.exec(netscape + " http://www.cs.columbia.edu/~mjs/ais");
                } catch (java.io.IOException ioe) {
                    System.out.println("Got IOE: " + ioe);
                }
            }
        });

        constr.gridwidth = constr.REMAINDER;
        constr.insets = new Insets(2, 0, 2, 0); // top, left, bot, right
        gridbag.setConstraints(home, constr);
        c.add (home);
        
        // set up center of main window with list tabs
        JTabbedPane tabs = new JTabbedPane();

        // add tabs: 1 for online active list, 2 for list configuration
        JPanel activepane = new JPanel();
        activepane.setLayout(new GridLayout(0, 1));
        for (int i=0; i<25; i++) {
            activepane.add(new JLabel("label # " + String.valueOf(i)));
        }
        
        JPanel setuppane = new JPanel();
        setuppane.add(new JLabel("setup goes here."));
        
        tabs.addTab("Online", new JScrollPane(activepane));
        tabs.addTab("List Setup", setuppane);
        
        constr = new GridBagConstraints();
        constr.weighty = 1.0;
        constr.weightx = 1.0;
        constr.fill = constr.BOTH;
        constr.gridwidth = constr.REMAINDER;
        gridbag.setConstraints(tabs, constr);
        c.add(tabs);

        JPanel bottombar = new JPanel();
        JButton config = new JButton("Configure");
        bottombar.add(config);
        
        JButton quit = new JButton("Quit");
        quit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                System.exit(0);
            }
        });
        bottombar.add(quit);
        c.add(bottombar);
        setSize(270, 450);
    }

    public static void main(String args[]) {
        if (args.length != 2) {
            usage();
        }

        try {
            UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
        } catch( Exception e ) {
            System.err.println( "Could not load look and feel" );
            e.printStackTrace();
        }

        _username = args[0];
        _password = args[1];

        BuddyListApp bla = new BuddyListApp();
        bla.show();
    }

    public static void usage() {
        System.out.println("Usage: java edu.columbia.sip.BuddyListApp <username> <password>");
        System.exit(1);
    }

}