package edu.columbia.sip;

public class SIPResponse extends SIPMessage {
    // version code reason-phrase
    private int _code;
    private String _reason;
    
    public SIPResponse(int code, String reason) {
        _code = code;
        _reason = reason;
        
        if (code < 100 || code > 699) {
            System.out.println("SIPResponse() Error: unsupported code " + code);
        }
    }        
    
    /** convenience constructor which extracts all relevant material
     * from the request to which we're responding and generates the 
     * appropriate headers in the response automatically.
     */
    public SIPResponse(SIPRequest request, int code, String reason) {
        this(code, reason);

        setHeader("From", request.getHeader("From")); 
        setHeader("To", request.getHeader("To"));
        
        setHeader(SIPToken.CALL_ID, request.getHeader(SIPToken.CALL_ID));
        // etc.
        
    } // end CTOR
    
    
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append(SIPToken.SIPVERSION);
        sb.append(' ');
        sb.append(String.valueOf(_code));
        sb.append(' ');
        sb.append(_reason);
        sb.append('\n');
        sb.append(getHeaders());
        sb.append(getContentLengthLine());
        sb.append('\n');
        sb.append(getContents());
        return sb.toString();
    }
}
