package edu.columbia.sip;

public class SIPURL {
// see Draft sec. 2 for definition
    private String _text;
    private String _host;
    private int _hport;
    
    public SIPURL(String s) {
        _text = s;
        if (! isValid(s)) {
            // throw an exception
            System.out.println("Exception in SIPURL.CTOR: '" + s + "' is not a valid URL.");
            Exception e = new Exception();
            e.printStackTrace();
        }
    }
    
    public boolean equals(SIPURL u) {
        return _text.equals(u._text);
    }
    
    public String getHost() {
        if (_host == null) {
            int startpos = _text.indexOf('@');
            if (startpos < 0) {
                startpos = 4;  // right after "sip:"
            }
            int endpos = _text.indexOf(';', startpos); 
            if (endpos <= startpos) {
                endpos = _text.length();
            }
            String hostport = _text.substring(startpos, endpos);
  //          System.out.println("SIPURL(): hostandport is '" + hostport + "'");
            int colonpos = hostport.indexOf(':');
            if (colonpos != -1) {
                _host = hostport.substring(0, colonpos);
                _hport = Integer.parseInt(hostport.substring(colonpos+1));
            } else {
                _host = hostport;
                _hport = -1;
            }
        } 
        
        return _host;
    }
    
    public int getPort() {
        if (_host == null) {
            getHost();
        }
        return _hport;
    }

    public static boolean isValid(String s) {
        if (! s.substring(0, 4).equals("sip:")) {
            return false;
        }
        
        return true;
    }

    public String toString() {
        return _text;
    }
}