package edu.columbia.sip.buddy;

import com.sun.java.swing.JPanel;
import com.sun.java.swing.JButton;

import mjs.graphical.jfc.ActiveButton;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import java.awt.Color;

public class BuddiesButtonBar extends JPanel {
    ActiveButton _add;
    ActiveButton _delete;
    ActiveButton _edit;
    BuddyList _bl;
    
    public BuddiesButtonBar(BuddyList blist) {
        _bl = blist;
        Color bgc = new Color(0, 70, 40);
        
        _add = new ActiveButton("Add", "Add", Color.white, Color.cyan, bgc, bgc, 
                                null, null);
        _add.setHighlightState(false);
        
        _add.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Buddy newbud = new Buddy("new");
                _bl.add(newbud);
                _bl.select(_bl.getItemCount() - 1);
                BuddyEditor be = new BuddyEditor(newbud);
                be.show();
            }
        });

        _delete = new ActiveButton("Delete");
        _delete.setNormalBG(bgc);
        _delete.setHighlightBG(bgc);
        _delete.setNormalFG(Color.white);
        _delete.setHighlightFG(new Color(255, 0, 20));
        _delete.setHighlightState(false);
        
        _delete.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // CAREFUL - no confirm on delete here!
                int item = _bl.getSelectedIndex();
                if (item >= 0) {
                    Buddy b = _bl.getBuddyAt(item);
                    b.dontListen();
                    _bl.remove(item);
                }
            }
        });                
        
        _edit = new ActiveButton("Edit");
        _edit.setNormalBG(bgc);
        _edit.setHighlightBG(bgc);
        _edit.setHighlightFG(Color.cyan);
        _edit.setNormalFG(Color.white);
        _edit.setHighlightState(false);
        _edit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Buddy toedit = _bl.getBuddyAt(_bl.getSelectedIndex());
                BuddyEditor be = new BuddyEditor(toedit);
                be.show();
            }
        });
        
        add(_add);
        add(_edit);
        add(_delete);
    }
}