package edu.columbia.sip.buddy;

import edu.columbia.sip.SIPServer;

import java.io.IOException;
import java.lang.Runnable;
import java.lang.Thread;
import java.util.Random;
import java.util.Vector;
import edu.columbia.sip.AvailabilityEvent;
import edu.columbia.sip.AvailabilityListener;


public class FakeServer extends SIPServer {
    private Vector _listeners;
    private Vector _states;
    
    public FakeServer(int mode, int port) throws IOException {
        super(mode, port);
        _listeners = new Vector();
        _states = new Vector();
        Alerter alerter = new Alerter(_listeners, _states);
        alerter.start();
    }
   
    
    public void addAvailabilityListener(AvailabilityListener al) {
        _listeners.addElement(al);
        _states.addElement(new Boolean(false));
    }
    
    public void removeAvailabilityListener(AvailabilityListener al) {
        int pos = _listeners.indexOf(al);
        _listeners.removeElement(al);
        _states.removeElementAt(pos);
    }
        
}

class Alerter extends Thread {
    private Vector _states;
    private int _herecount;
    private Vector _listeners;
    private Random _rand;
    private Boolean _false;
    private Boolean _true;
    
    public Alerter(Vector v, Vector s) {
        _listeners = v;
        _states = s;
        _herecount = 0;
        _rand = new Random();
        _false = new Boolean(false);
        _true = new Boolean(true);
    }
    
    public void run() {
        int pos = 0;
        int siz = 0;
        AvailabilityEvent ae = new AvailabilityEvent(this);
        
        while (true) {
            siz = _listeners.size();
            if (siz < 1) {
                try {
                    sleep(600);
                } catch (Exception e) {}
            } else {
                pos = (int) (siz * _rand.nextFloat());
                if (((Boolean) _states.elementAt(pos)).booleanValue()) {
                    if (_herecount > 2) {
                        _herecount--;
                        _states.setElementAt(_false, pos);
                        ((AvailabilityListener) _listeners.elementAt(pos)).gone(ae);
                    } 
                } else {
                    _herecount++;
                    _states.setElementAt(_true, pos);
                    ((AvailabilityListener) _listeners.elementAt(pos)).here(ae);
                }
                try {
                    sleep(6000); 
                } catch (Exception e) {}
            }
            
        }
    }
}