package mjs.util;

public class Debug {
    public static boolean verbose = ((System.getProperty("Debug") != null) &&
                                     (System.getProperty("Debug") != "off"));

    public static boolean isVerbose() {
        return verbose;
    }

    public static boolean isVerbose(Object o) {
        if (verbose) {
            return true;
        }

        String name = o.getClass().getName();
        String s = System.getProperty("Debug" + name);
        return ((s != null) && (s.equalsIgnoreCase("true") || s.equalsIgnoreCase("on")));
    }

    public static void println(String s) {
        if (verbose) {
            System.out.println(s);
        }
    }

    public static void println(Object o, String s) {
        if (isVerbose(o)) {
            StringBuffer sb = new StringBuffer(getShortName(o));
            sb.append('.');
            sb.append(getCurrentMethod());
            sb.append("() ");
            sb.append(s);
            System.out.println(sb.toString());
        }
    }

    public static String getShortName(Object o) {
        String name = o.getClass().getName();
        return name.substring(name.lastIndexOf('.') + 1);
    }

    public static String getCurrentMethod() {
        return "";
    }
}

